HDU 5063 Operation the Sequence

做题感悟:这题开始以为是找规律,果断悲剧阿,最后才意识到应该逆着退回去。

解题思路:

这题的突破口就是要逆向推回去,这样复杂度为 50 * m 的复杂度。做完这题还学到一点就是如果取模的数为素数,可以让指数先对素数减一取模,取模后指数就比较小了。

代码:

#include<iostream>
#include<sstream>
#include<map>
#include<cmath>
#include<fstream>
#include<queue>
#include<vector>
#include<sstream>
#include<cstring>
#include<cstdio>
#include<stack>
#include<bitset>
#include<ctime>
#include<string>
#include<cctype>
#include<iomanip>
#include<algorithm>
using namespace std  ;
#define INT __int64
#define L(x)  (x * 2)
#define R(x)  (x * 2 + 1)
const int INF = 0x3f3f3f3f ;
const double esp = 0.0000000001 ;
const double PI = acos(-1.0) ;
const INT mod = 1e9 + 7 ;
const int MY = 1e7 + 5 ;
const int MX = 100000 + 5 ;
int n ,m ;
struct node
{
    int x ,y ;
}T[MX] ;
INT pow(INT a ,int k ,INT mod)
{
    INT b = 1 ;
    while(k)
    {
        if(k&1)
            b = (b*a)%mod ;
        a = (a*a)%mod ;
        k>>= 1 ;
    }
    return b ;
}
int main()
{
    //freopen("input.txt" ,"r" ,stdin) ;
    int Tx ;
    scanf("%d" ,&Tx) ;
    while(Tx--)
    {
        scanf("%d%d" ,&n ,&m) ;
        memset(T ,0 ,sizeof(T)) ;
        char ch ; int x ,temp ;
        for(int i = 0 ;i < m ; ++i)
        {
            cin>>ch>>x ;
            if(ch == 'Q')
                T[i].x = 1 ;
            T[i].y = x ;
        }
        for(int i = 0 ;i < m ; ++i)
          if(T[i].x)
          {
              int num = 0 ,St = T[i].y ;
              for(int j = i ;j >= 0 ; --j)
              {
                  if(T[j].x)  continue ;
                  if(T[j].y == 1)
                  {
                      if(n%2)  temp = n/2 + 1 ;
                      else     temp = n/2 ;
                      if(St <= temp)
                           St = St*2 - 1 ;
                      else St = (St - temp)*2 ;

                  }
                  else if(T[j].y == 2)
                      St = n - St + 1 ;
                  else  num++ ;
              }
              if(!num)  cout<<St<<endl ;
              else
                  cout<<pow((INT)St ,pow(2 ,num ,mod-1) ,mod)<<endl ;
          }
    }
    return 0 ;
}
时间: 2024-08-05 00:00:03

HDU 5063 Operation the Sequence的相关文章

HDU 5063 Operation the Sequence(暴力)

HDU 5063 Operation the Sequence 题目链接 把操作存下来,由于只有50个操作,所以每次把操作逆回去运行一遍,就能求出在原来的数列中的位置,输出即可 代码: #include <cstdio> #include <cstring> #include <algorithm> using namespace std; typedef long long ll; const int N = 100005; const ll MOD = 100000

hdu 5063 Operation the Sequence(Bestcoder Round #13)

Operation the Sequence                                                                     Time Limit: 3000/1500 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 158    Accepted Submission(s): 74 Problem Description

HDU 5063 Operation the Sequence(暴力 数学)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5063 Problem Description You have an array consisting of n integers: a1=1,a2=2,a3=3,-,an=n. Then give you m operators, you should process all the operators in order. Each operator is one of four types: T

HDU 5063 Operation the Sequence(仔细审题)

http://acm.hdu.edu.cn/showproblem.php?pid=5063 题目大意: 题目意思还是比较简单.所以就不多少了.注意这句话,对解题有帮助. Type4: Q i query current value of a[i], this operator will have at most 50. 解题思路: 因为给定n和m都是100000,我们每一步都做具体的操作,时间将是O(n*m),肯定超时.最开始的时候 我怎么想都不知道怎么解决.以为是线段树.比赛完了以后,看了解

HDU 5063 Operation the Sequence(BestCoder Round #13)

Problem Description: You have an array consisting of n integers: a1=1,a2=2,a3=3,…,an=n. Then give you m operators, you should process all the operators in order. Each operator is one of four types:Type1: O 1 call fun1();Type2: O 2 call fun2();Type3:

HDOJ 5063 Operation the Sequence

注意到查询次数不超过50次,那么能够从查询位置逆回去操作,就能够发现它在最初序列的位置,再逆回去就可以求得当前查询的值,对于一组数据复杂度约为O(50*n). Operation the Sequence Time Limit: 3000/1500 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 463    Accepted Submission(s): 187 Problem

【HDOJ】5063 Operation the Sequence

1 #include <cstdio> 2 #include <cstring> 3 #include <cstdlib> 4 5 #define MAXN 100005 6 #define MOD 1000000007 7 int que[MAXN], front = 0, rear = 0; 8 int n; 9 10 void query(int index) { 11 int r = rear; 12 int square = 0; 13 int half =

HDU - 5036 Operation the Sequence

Problem Description You have an array consisting of n integers: a1=1,a2=2,a3=3,-,an=n. Then give you m operators, you should process all the operators in order. Each operator is one of four types: Type1: O 1 call fun1(); Type2: O 2 call fun2(); Type3

hdu 4893 Wow! Such Sequence!(线段树功能:单点更新,区间更新相邻较小斐波那契数)

转载请注明出处:http://blog.csdn.net/u012860063?viewmode=contents 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4893 --------------------------------------------------------------------------------------------------------------------------------------------